from cadmath import *
import math

class Draw3D:
    def __init__(self,graph):
        self.graph=graph
##
##    def curve(self,p3dlist,close=0,color=None,hiddencolor=None): # weitere params?
##        graph=self.graph
##        p3d0=p3dlist[0]
##        if hiddencolor==None:
##            for p3d1 in p3dlist:
##                if p3d0.visibility and p3d1.visibility: graph.drawLine3D(p3d0,p3d1,color=color)
##                p3d0=p3d1
##            if close:
##                p3d1=p3dlist[0]
##                if p3d0.visibility and p3d1.visibility: graph.drawLine3D(p3d0,p3d1,color=color)
##        else:
##            for p3d1 in p3dlist:
##                if p3d0.visibility and p3d1.visibility: graph.drawLine3D(p3d0,p3d1,color=color)
##                else: graph.drawLine3D(p3d0,p3d1,color=hiddencolor) # gestrichelt?
##                p3d0=p3d1
##            if close:
##                p3d1=p3dlist[0]
##                if p3d0.visibility and p3d1.visibility: graph.drawLine3D(p3d0,p3d1,color=color)
##                else: graph.drawLine3D(p3d0,p3d1,color=hiddencolor) # gestrichelt?

    def lineOverPlane(self,v3d0,v3d1,n_v3d,d,side=-1,hiddenline=1,color=None,linewidth=None,stippled=None): # Zeichnet Linie vor Ebene
        graph=self.graph
        dis0=n_v3d.scalarProduct(v3d0)-d
        dis1=n_v3d.scalarProduct(v3d1)-d
        if side<0: dis0,dis1=-dis0,-dis1
        if dis0>=0 and dis1>=0:	graph.drawLine3D(v3d0,v3d1,color,linewidth,stippled)
        else:
            if dis0<0 and dis1<0:
                if hiddenline: graph.drawLine3D(v3d0,v3d1,color,linewidth,stippled=1)
            else:
                dis2=-dis0/float(dis1-dis0)
                v3d2=function_linearCombine3D(v3d0,1-dis2,v3d1,dis2)
                if dis0>=0: #v3d vor Ebene
                    graph.drawLine3D(v3d0,v3d2,color,linewidth,stippled)
                    if hiddenline: graph.drawLine3D(v3d1,v3d2,color,linewidth,stippled=1)
                else:
                    graph.drawLine3D(v3d1,v3d2,color,linewidth,stippled)
                    if hiddenline: graph.drawLine3D(v3d0,v3d2,color,linewidth,stippled=1)

    def curveOverPlane(self,v3dlist,n_v3d,d,side=-1,hiddenline=1,close=0,color=None,linewidth=None,stippled=None):
        length=len(v3dlist)-1
        for counter in range(length): self.lineOverPlane(v3dlist[counter],v3dlist[counter+1],n_v3d,d,side,hiddenline,color,linewidth,stippled)
        if close: self.lineOverPlane(v3dlist[0],v3dlist[length],n_v3d,d,side,hiddenline,color,linewidth,stippled)


        


        
            
        
    
    