from lib.cadmath import *

graph.reset()
graph.clear()
graph.setAngles(45,18)

o3d=Torus(220,60,36,18)

for face in o3d.facelist:
	nodelist=face.nodelist
        normalv3d,distance=function_GetPlaneEquation(nodelist[0].v3d,nodelist[1].v3d,nodelist[2].v3d)
        orientation=normalv3d.scalarProduct(graph.centrev3d)-distance
	if orientation>=0.0:
		for edge in face.edgelist:
			startv2d=graph.convertV3DToV2D(edge.startnode.v3d)
			endv2d=graph.convertV3DToV2D(edge.endnode.v3d)
			graph.drawLine2D(startv2d,endv2d)

graph.drawAxes3D(100)
